************************************************************************
*
*     Code to adjust DACs and MUXes in the clover modules.
*
************************************************************************
      implicit none

      integer*4     i, j, dac, id, idac, j2, num_mods, chan, isub
      integer*4     crate(20), slot(20)
      integer*4     dac_val, mux_value(20), control_value(20)
      real*4        fval
      character*40  ans, ans0
      logical       mod

      real*4        dac_set(32,20)
      integer*4     cc(200),cn(200),ca(200),cf(200),st(200)
      integer*2     rd(200),wr(200)
      common /camac/ cc,cn,ca,cf,rd,wr,st

      character*80  junk
      real          dac_range, dac_step
      data          dac_range, dac_step, mod /5.0, 0.02, .false./


      open(1,file='setup.dat',status='old',err=999)
      write(6,*) 'Reading data from file setup.dat...'

      do id = 1, 20
         read(1,'(a)',err=999,end=999) junk
         read(1,'(2i10)',err=999,end=999) crate(id), slot(id)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j,id),j=1,12)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j,id),j=13,15)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(4f10.4)',err=999,end=999) (dac_set(j,id),j=16,23)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(f10.4)',err=999,end=999) (dac_set(j,id),j=24,24)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(5f10.4)',err=999,end=999) (dac_set(j,id),j=25,29)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(z4)',err=999,end=999) mux_value(id)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(i10)',err=999,end=999) control_value(id)
         read(1,'(a)',err=999,end=999) junk
      enddo

 999  close(1)
      if (id.le.1) call exit(-1)
      num_mods = id - 1

      chan = 1
      ans0 = ' '
 1000 id   = (chan+3)/4
      isub = chan + 4 - id*4
      idac = isub*3 - 2
      cc(1) = crate(id)
      cn(1) = slot(id)
      cf(1) = 16

      write(6,'(//1x,a,i2,a/1x,a,2i3/)')
     &     'Detector number', id, char(96+isub),
     &     '  Crate, slot:', crate(id), slot(id)

      write(6,'(1x,a,i2)')   '  Setting MUXes 1, 3 and 4 to', isub
      ca(1) = 8
      wr(1) = '8088'x + (isub-1)*'0111'x 
      call camlist(cc,cn,ca,cf,0,wr,1,st)

      if (id.lt.1 .or. id.gt.num_mods) go to 1000
      write(6,1400) idac, dac_set(idac,id)

 1200 write(6,1250)
 1250 format (
     +' u/U, d/D  = up, down (fine/course)'/
     +'        z  = set to zero'/
     +'     n, p  = next, previous channel'/
     +' <number>  = skip to specified detector/module'/
     +'        h  = give this message'/
     +'        q  = quit'/
     +'    <rtn>  = repeat'/)

 1300 write(6,'(1x,a,$)') '? '
      read(5,'(a40)') ans
      if (ans(1:4).eq.'    ') ans = ans0
      ans0 = ans

      if (ans(1:1).eq.'q') then
         ca(1) = 8
         wr(1) = '8800'x
         call camlist(cc,cn,ca,cf,0,wr,1,st)
         go to 9000

      else if (ans(1:1).ge.'1' .and. ans(1:1).le.'9') then
         if (ans(2:2).eq.' ') then
            read(ans,'(i1)',err=1300) j
         else
            read(ans,'(i2)',err=1300) j
         endif
         if (j.lt.1 .or. j.gt.num_mods) then
            write(6,*) 'ERROR - bad detector/module number'
            write (6,1250)
            go to 1300
         endif
         ca(1) = 8
         wr(1) = '8800'x
         call camlist(cc,cn,ca,cf,0,wr,1,st)
         chan = j*4 - 3
         go to 1000

      else if (ans(1:1).eq.'n' .or. ans(1:1).eq.'p') then
         if (ans(1:1).eq.'n') chan = chan + 1
         if (ans(1:1).eq.'p') chan = chan - 1
         if (chan .gt. num_mods*4) chan = 1
         if (chan .lt. 1) chan = num_mods*4
         ca(1) = 8
         wr(1) = '8800'x
         call camlist(cc,cn,ca,cf,0,wr,1,st)
         go to 1000

      else if (ans(1:1).eq.'u') then
         dac_set(idac,id) = dac_set(idac,id) + dac_step
      else if (ans(1:1).eq.'U') then
         dac_set(idac,id) = dac_set(idac,id) + 10.0*dac_step
      else if (ans(1:1).eq.'d') then
         dac_set(idac,id) = dac_set(idac,id) - dac_step
      else if (ans(1:1).eq.'D') then
         dac_set(idac,id) = dac_set(idac,id) - 10.0*dac_step
      else if (ans(1:1).eq.'z') then
         dac_set(idac,id) = 0.0
      else
         go to 1200
      endif

      mod = .true.
      write(6,1400) idac, dac_set(idac,id)
 1400 format('  DAC number', i3,' =',f5.2, 'V.')
      fval = 256.0 * dac_set(idac,id) / dac_range + 128.0
      dac_val = fval
      i = (idac-1)/8
      ca(1) = i + 1
      dac = idac - 8*i
      wr(1) = dac_val + dac*256
      call camlist(cc,cn,ca,cf,0,wr,1,st)
      go to 1300

 9000 continue
      if (mod) then
 9010    write(6,'(1x,a,$)') 'Save modified values to setup.dat? (y/n)'
         read (5,'(a)') ans
         if (ans(1:1).eq.'y' .or. ans(1:1).eq.'Y') then
c-----------------------------
      open(1,file='setup.dat',status='old',err=999)
      write(6,*) 'Writing data to file setup.dat...'

      do id = 1, num_mods

         write(1,'(a)') '*   crate, slot'
         write(1,'(i3,a,i3,a)')
     +        crate(id), ',', slot(id), ','
         write(1,'(a)') '*   hires cfd_thresh, cfd_walk, pileup_thresh'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=1,3),   '     ! Ge1  Dacs 1-3'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=4,6),   '     ! Ge2  Dacs 4-6'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=7,9),   '     ! Ge3  Dacs 7-9'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=10,12), '     ! Ge4  Dacs 10-12'
         write(1,'(a)') '*   lores conv_thresh (x3)'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=13,15),
     +        '     ! Side channels  Dacs 13-15'
         write(1,'(a)') '*   BGO indiv hit thresh  (x8)'
         write(1,'(4(f5.2,'',''),a)')
     +        (dac_set(j,id),j=16,19), '     ! BGO  Dacs 16-19'
         write(1,'(4(f5.2,'',''),a)')
     +        (dac_set(j,id),j=20,23), '     ! BGO  Dacs 20-23'
         write(1,'(a)') '*   BGO sum conv thresh'
         write(1,'(f5.2,'','',a)')
     +        (dac_set(j,id),j=24,24), '     ! BGO Sum  Dac 24'
         write(1,'(a)') '*   Ge T delay;  100 to 200ns = -5 to 5V'
         write(1,'(5(f5.2,'',''),a)')
     +        (dac_set(j,id),j=25,29), '     ! CFD Delays  Dacs 25-29'
         write(1,'(a)') '*   multiplexer value; '//
     &        '4bits each for Digital2,Digital1,Analog2,Analog1'
         write(1,'(a)')
     +        '8800,        ! mux_value, in hex'
         write(1,'(a)') '*  control register value'
         write(1,'(i2,'','',a)')
     +        control_value(id),
     +        '     ! bits 0/1/2 = fera_mode/pileup_mode/energy_range'
         write(1,'(a)') '*---------------------------------------'

      enddo
      close(1)
c-----------------------------
         elseif (ans(1:1).ne.'n' .and. ans(1:1).ne.'N') then
            go to 9010
         endif
      endif
      call exit(0)

      end
