************************************************************************
*
*     Code to initialize DACs in the clover module.
*
************************************************************************
      implicit none

      integer*4     i, j, dac, idet, crate, slot, dac_val
      real*4        fval

      real*4        dac_set(32)
      integer*4     cc(200),cn(200),ca(200),cf(200),st(200)
      integer*2     rd(200),wr(200)
      common /camac/ cc,cn,ca,cf,rd,wr,st

      character*80  junk
      integer*4     mux_value, control_value
      real          dac_range
      data          dac_range /5.0/
      data          dac_set /
C     hires cfd_thresh, cfd_walk, pileup_thresh
     1    0.26, 0.50, 0.60,      !GE1  Dacs 1-3    ge 1
     2    0.26, 0.50, 0.60,      !GE2  Dacs 4-6    ge 2
     3    0.26, 0.50, 0.60,      !GE3  Dacs 7-9    ge 3
     4    0.26, 0.50, 0.60,      !GE4  Dacs 10-12  ge 4
C     lores conv_thresh (x3)
     5    -0.02,-0.02,-0.02,     !Side channels  Dacs 13-15
C     BGO indiv hit thresh  (x8)
     6    -0.5,-0.5,-0.5,-0.5,-0.5,-0.5,-0.5,-0.5, !BGO  Dacs 16-23
C     BGO sum conv thresh
     7    -0.02,                           !BGO SUM    Dac 24
C     ge T delays   100-200ns == 0-255
     8    1.2, 1.2, 1.2, 1.2, 1.2,  !CFD Delays  Dacs 25-29
     9    -1.25,-1.25,-1.25   !Unused Dacs 30-32
     1    /


      crate = 1
      slot = 10

      mux_value = '278F'x   ! 4bits each for Digital2,Digital1,Analog2,Analog1
*  digital 1 : cfd1 cfd2 cfd3 cfd4 sumlogic gedelay bgotest pu_sum
*  digital 2 : bgohit1 bgohit2 ... bgohit8
*  analog 1  : gemon1 ... gemon4 sidemon1 sidemon2 sidemon3 bgomon
*  analog 2  : fast1 ... fast4 sidemon1 sidemon2 sidemon3 bgomon
*                digitals are enabled by bit4 = 0 (for now, maybe 1 later)
*                analogs  are enabled by bit4 = 1

      control_value = 2

      open(1,file='setup.dat',status='old',err=999)
      write(6,*) 'Reading data from file setup.dat...'

      do idet = 1, 12
         read(1,'(a)',err=999,end=999) junk
         read(1,'(2i10)',err=999,end=999) crate, slot
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j),j=1,12)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j),j=13,15)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(4f10.4)',err=999,end=999) (dac_set(j),j=16,23)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(f10.4)',err=999,end=999) (dac_set(j),j=24,24)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(5f10.4)',err=999,end=999) (dac_set(j),j=25,29)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(z4)',err=999,end=999) mux_value
         read(1,'(a)',err=999,end=999) junk
         read(1,'(i10)',err=999,end=999) control_value
         read(1,'(a)',err=999,end=999) junk
         write(6,*) crate, slot, dac_set, mux_value, control_value

*   Test for crate on-line
         call camacio(0,crate,30,0,1,rd,1,st)
         if (st(1) .ne. 0) call exit(99)
         do i = 1, 200
            cc(i) = crate
            cn(i) = slot
            cf(i) = 16
         enddo

*   Set the default values for ALL DACs
         do j = 1, 32
            fval = 256.0 * dac_set(j) / dac_range + 128.0
            dac_val = nint(fval)
            i = (j-1)/8
            ca(j) = i + 1
            dac = j - 8*i
            wr(j) = dac_val + dac*256
         enddo

*  set multiplexers
         j = 33
         ca(j) = 8
         wr(j) = mux_value

*  Set the control register
         j = 34
         cf(j) = 17
         ca(j) = 2
         wr(j) = control_value

         do i = 1, j
            write(6,1000) cc(i), cn(i), ca(i), cf(i), wr(i), i
 1000       format(4i3,z4,3x,'#',i2)
         enddo
         call camlist(cc,cn,ca,cf,0,wr,j,st)

      enddo

 999  close(1)
      call exit(0)

      end

