************************************************************************
*
*     Code to adjust DACs and MUXes in the clover modules.
*
************************************************************************
      implicit none

      integer*4     i, j, dac, id, idac, j2, num_mods
      integer*4     crate(20), slot(20)
      integer*4     dac_val, mux_value(20), control_value(20)
      real*4        fval
      character*40  ans, ans0
      character*1   mode
      logical       mod

      real*4        dac_set(32,20)
      integer*4     cc(200),cn(200),ca(200),cf(200),st(200)
      integer*2     rd(200),wr(200)
      common /camac/ cc,cn,ca,cf,rd,wr,st

      character*80  junk
      real          dac_range, dac_step
      data          dac_range, dac_step, mod /5.0, 0.02, .false./


      open(1,file='setup.dat',status='old',err=999)
      write(6,*) 'Reading data from file setup.dat...'

      do id = 1, 20
         read(1,'(a)',err=999,end=999) junk
         read(1,'(2i10)',err=999,end=999) crate(id), slot(id)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j,id),j=1,12)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(3f10.4)',err=999,end=999) (dac_set(j,id),j=13,15)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(4f10.4)',err=999,end=999) (dac_set(j,id),j=16,23)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(f10.4)',err=999,end=999) (dac_set(j,id),j=24,24)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(5f10.4)',err=999,end=999) (dac_set(j,id),j=25,29)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(z4)',err=999,end=999) mux_value(id)
         read(1,'(a)',err=999,end=999) junk
         read(1,'(i10)',err=999,end=999) control_value(id)
         read(1,'(a)',err=999,end=999) junk
      enddo

 999  close(1)
      if (id.le.1) call exit(-1)
      num_mods = id - 1

 1000 write(6,'(1x,a,$)')
     + 'Type d to set DACs, m to set MUXes, or  q to quit. > ? '
      read (5,'(a1)',err=1000) mode
      if (mode.eq.'q') go to 9000
      if (mode.ne.'d' .and. mode.ne.'m') go to 1000

 1100 write(6,*) 'Select module number (1 to ', num_mods, ')'
      write(6,'(12x,a,$)') 'or q to quit this mode. > ? '
      read (5,'(i)',err=1000) id
      write(6,*) '  ... module number:', id
      if (id.lt.1 .or. id.gt.num_mods) go to 1000
      write(6,*) '  ... crate, slot:', crate(id), slot(id)

      if (mode.eq.'d') then
 1200    continue
         idac = 0
         ans0 = ' '
         write(6,1250)
 1250    format (
     +'  1  2  3  = cfd_thresh, cfd_walk, pileup_thresh   ge 1'/
     +'  4  5  6  = cfd_thresh, cfd_walk, pileup_thresh   ge 2'/
     +'  7  8  9  = cfd_thresh, cfd_walk, pileup_thresh   ge 3'/
     +' 10 11 12  = cfd_thresh, cfd_walk, pileup_thresh   ge 4'/
     +' 13 14 15  = lores conv_thresh (side1, side2, side3)'/
     +' 16 to 23  = BGO indiv hit thresh (bgo1, bgo2, ... bgo8)'/
     +'       24  = BGO sum conversion thresh'/
     +' 25 to 29  = CFD delays'/
     +' u/U, d/D  = up, down (fine/course)'/
     +'        z  = set to zero'/
     +'        h  = give this message'/
     +'        q  = quit this module'/
     +'    <rtn>  = repeat'/)

 1300    write(6,'(1x,a,$)') 'dacs> ? '
         read(5,'(a40)') ans
         if (ans(1:4).eq.'    ') ans = ans0
         ans0 = ans

         if (ans(1:1).eq.'q') then
            go to 1100

         else if (ans(1:1).ge.'1' .and. ans(1:1).le.'9') then
            if (ans(2:2).eq.' ') then
               read(ans,'(i1)',err=1300) j
            else
               read(ans,'(i2)',err=1300) j
            endif
            if (j.lt.1 .or. j.gt.29) then
               write(6,1250)
               go to 1300
            endif
            idac = j
            write(6,1400) idac, dac_set(idac,id)
 1400       format('  DAC number', i3,' =',f5.2, 'V.')
            go to 1300

         else if (idac.lt.1) then
            write (6,1250)
            go to 1300

         else if (ans(1:1).eq.'u') then
            dac_set(idac,id) = dac_set(idac,id) + dac_step
         else if (ans(1:1).eq.'U') then
            dac_set(idac,id) = dac_set(idac,id) + 10.0*dac_step
         else if (ans(1:1).eq.'d') then
            dac_set(idac,id) = dac_set(idac,id) - dac_step
         else if (ans(1:1).eq.'D') then
            dac_set(idac,id) = dac_set(idac,id) - 10.0*dac_step
         else if (ans(1:1).eq.'z') then
            dac_set(idac,id) = 0.0
         else
            write(6,1250)
            go to 1300
         endif

         mod = .true.
         write(6,1400) idac, dac_set(idac,id)
         fval = 256.0 * dac_set(idac,id) / dac_range + 128.0
         dac_val = fval
         cc(1) = crate(id)
         cn(1) = slot(id)
         cf(1) = 16
         i = (idac-1)/8
         ca(1) = i + 1
         dac = idac - 8*i
         wr(1) = dac_val + dac*256

         call camlist(cc,cn,ca,cf,0,wr,1,st)
         go to 1300

      elseif (mode.eq.'m') then

         cc(1) = crate(id)
         cn(1) = slot(id)
         cf(1) = 16
         ca(1) = 8
         wr(1) = mux_value(id)

 2000    continue
         write(6,2050)
 2050    format (
     +'     1 = digital1, 2 = digital2, 3 = analog1, 4 = analog2'/
     +'     h = this message'/
     +'     q = quit this module')

         read(5,'(a40)') ans

         if (ans(1:1).eq.'q') then
            go to 1100

*                digitals are enabled by bit4 = 0 (for now, maybe 1 later)
*                analogs  are enabled by bit4 = 1
         else if (ans(1:1).eq.'1') then
            write(6, 9110)
 9110       format ('  0 = disable,'/
     +           '1-8 = cfd1 cfd2 cfd3 cfd4 ',
     +           ' sumlogic gedelay bgotest pu_sum  ? ',$)
            read(5,'(i)',err=2000) j2
            if (j2.eq.0) j2 = 9
            wr(1) = wr(1) .and. 'f0ff'x
            wr(1) = wr(1) + (j2-1)*'100'x
         else if (ans(1:1).eq.'2') then
            write(6, 9120)
 9120       format ('  0 = disable,'/
     +           '1-8 = bgohit1 bgohit2 ... bgohit8  ? ',$)
            read(5,'(i)',err=2000) j2
            if (j2.eq.0) j2 = 9
            wr(1) = wr(1) .and. '0fff'x
            wr(1) = wr(1) + (j2-1)*'1000'x
         else if (ans(1:1).eq.'3') then
            write(6, 9130)
 9130       format ('  0 = disable,'/
     +           '1-8 = gemon1 gemon2 gemon3 gemon4 ',
     +           ' sidemon1 sidemon2 sidemon3 bgomon  ? ',$)
            read(5,'(i)',err=2000) j2
            wr(1) = wr(1) .and. 'fff0'x
            if (j2.gt.0) wr(1) = wr(1) + (j2+7)*'1'x
         else if (ans(1:1).eq.'4') then
            write(6, 9140)
 9140       format ('  0 = disable,'/
     +           '1-8 = fast1 fast2 fast3 fast4 ',
     +           ' sidemon1 sidemon2 sidemon3 bgomon  ? ',$)
            read(5,'(i)',err=2000) j2
            wr(1) = wr(1) .and. 'ff0f'x
            if (j2.gt.0) wr(1) = wr(1) + (j2+7)*'10'x

         else
            go to 2000
         endif

         call camlist(cc,cn,ca,cf,0,wr,1,st)
         go to 2000
      endif

 9000 continue
      if (mod) then
 9010    write(6,'(1x,a,$)') 'Save modified values to setup.dat? (y/n)'
         read (5,'(a)') ans
         if (ans(1:1).eq.'y' .or. ans(1:1).eq.'Y') then
c-----------------------------
      open(1,file='setup.dat',status='old',err=999)
      write(6,*) 'Writing data to file setup.dat...'

      do id = 1, num_mods

         write(1,'(a)') '*   crate, slot'
         write(1,'(i3,a,i3,a)')
     +        crate(id), ',', slot(id), ','
         write(1,'(a)') '*   hires cfd_thresh, cfd_walk, pileup_thresh'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=1,3),   '     ! Ge1  Dacs 1-3'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=4,6),   '     ! Ge2  Dacs 4-6'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=7,9),   '     ! Ge3  Dacs 7-9'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=10,12), '     ! Ge4  Dacs 10-12'
         write(1,'(a)') '*   lores conv_thresh (x3)'
         write(1,'(3(f5.2,'',''),a)')
     +        (dac_set(j,id),j=13,15),
     +        '     ! Side channels  Dacs 13-15'
         write(1,'(a)') '*   BGO indiv hit thresh  (x8)'
         write(1,'(4(f5.2,'',''),a)')
     +        (dac_set(j,id),j=16,19), '     ! BGO  Dacs 16-19'
         write(1,'(4(f5.2,'',''),a)')
     +        (dac_set(j,id),j=20,23), '     ! BGO  Dacs 20-23'
         write(1,'(a)') '*   BGO sum conv thresh'
         write(1,'(f5.2,'','',a)')
     +        (dac_set(j,id),j=24,24), '     ! BGO Sum  Dac 24'
         write(1,'(a)') '*   Ge T delay;  100 to 200ns = -5 to 5V'
         write(1,'(5(f5.2,'',''),a)')
     +        (dac_set(j,id),j=25,29), '     ! CFD Delays  Dacs 25-29'
         write(1,'(a)') '*   multiplexer value; '//
     &        '4bits each for Digital2,Digital1,Analog2,Analog1'
         write(1,'(a)')
     +        '8800,        ! mux_value, in hex'
         write(1,'(a)') '*  control register value'
         write(1,'(i2,'','',a)')
     +        control_value(id),
     +        '     ! bits 0/1/2 = fera_mode/pileup_mode/energy_range'
         write(1,'(a)') '*---------------------------------------'

      enddo
      close(1)
c-----------------------------
         elseif (ans(1:1).ne.'n' .and. ans(1:1).ne.'N') then
            go to 9010
         endif
      endif
      call exit(0)

      end
